#ifndef UTILS_H
#define UTILS_H

char *sha1_file    (char       *path);
char *read_symlink (char       *path);
char *build_path   (const char *dir,
		    const char *file);
int   copy_file    (char       *source,
		    char       *dest,
		    int         mode);
int   copy_fd      (int         source_fd,
		    char       *dest,
		    int         mode);
int   safe_strcmp  (const char *str1,
		    const char *str2);



typedef struct {
  char *string;
  int count;
} string_info;

typedef struct {
  string_info *strings;
  int n_strings;
  int allocated_strings;
} string_collector;

string_info      *string_collector_lookup (string_collector *s,
					   const char       *strings);
void              string_collector_add    (string_collector *s,
					   const char       *string);
string_collector *string_collector_new    (void);
void              string_collector_free   (string_collector *l);






#endif /* UTILS_H */
